<template>
    <div>
        <div class="communal-list">
            <div>

                <div class="communal-title">
                    <div>其他款项</div>
                </div>
                <div class="dphade" style="display: flex;">
                    <div style="width: 50%;">
                        <el-select style="width:300px" v-model="DiId" placeholder="团组选择" clearable filterable @change="DecreasePaymentsChange">
                            <el-option v-for="item in delegationInfoList" :key="item.id" :label="item.teamName"
                                :value="item.id">
                            </el-option>
                        </el-select>
                    </div>
                    <div style="width:50%;text-align: right;display: flex;justify-content: flex-end;">
                        <el-upload
                        class="upload-demo"
                        ref="upload"
                        action="http://132.232.92.186:8888/api/Groups/DecreasePaymentsOTAMate"
                        :on-preview="handlePreview"
                        :on-remove="handleRemove"
                        :on-success="handleSuccess"
                        :on-error="handleError"
                        :file-list="fileList"
                        :limit="1"
                        :auto-upload="false">
                        <el-button slot="trigger" size="small" type="primary"> wifi表格匹配团组</el-button>
                        <el-button style="margin-left: 10px;" size="small" type="success" @click="submitUpload">上传</el-button>
                        <div slot="tip" class="el-upload__tip">更换wifi表格匹配请移除后重新选择！</div>
                        </el-upload>
                        <router-link :to="{ path: '/home/OpDecreasePayments', query: { DiId } }">
                            <el-button size="small" type="primary" style="margin-left: 10px;">新增</el-button>
                        </router-link>
                    </div>
                </div>
                <div class="communal-box-title">
                    <span>团队名称：</span>
                    {{ delegationInfo.teamName }}&nbsp;&nbsp;&nbsp;
                    <span>客户：</span>
                    {{ delegationInfo.clientName }}&nbsp;&nbsp;&nbsp;
                    <span>出访国家：</span>
                    {{ delegationInfo.visitCountry |filter_city}}&nbsp;&nbsp;&nbsp;
                    <span>起止日期：</span>
                    {{ delegationInfo.visitStartDate|filter_time }}—{{ delegationInfo.visitEndDate|filter_time }}&nbsp;&nbsp;&nbsp;
                    <span>天数/人数：</span>
                    {{ delegationInfo.visitDays }}天/{{ delegationInfo.visitPNumber }}人
                </div>
            </div>
            <template>
                <el-table :data="tableDatas.slice((currentPage - 1) * pageSize, currentPage * pageSize)" border
                    style="width: 100%" v-loading="loading" element-loading-text="拼命加载中...">
                    <el-table-column prop="num" label="序 号" width="55">
                        <template slot-scope="scope">
                            {{ (currentPage - 1) * pageSize + scope.$index + 1 }}
                        </template>
                    </el-table-column>
                    <el-table-column prop="priceName" label="费用名称" width="260">
                    </el-table-column>
                    <el-table-column label="费用" sortable>
                        <template slot-scope="scope">
                            {{ townum(scope.row.feeTotal) }}({{ scope.row.currency }})
                        </template>
                    </el-table-column>
                    <el-table-column prop="filePath" label="附件">
                    </el-table-column>
                    <el-table-column prop="createUserName" label="操作人" width="100">
                    </el-table-column>
                    <el-table-column prop="createTime" label="操作时间">
                    </el-table-column>
                    <el-table-column prop="isAudit" label="是否审核" width="90">
                        <template slot-scope="isAudit">
                            <span v-if="isAudit.row.isAudit == 1">已通过</span>
                            <span v-else-if="isAudit.row.isAudit == 0">未审核</span>
                            <span v-else-if="isAudit.row.isAudit == 2">未通过</span>
                            <span v-else>自动审核通过</span>
                        </template>
                    </el-table-column>
                    <el-table-column prop="isPay" label="是否支付" width="90">
                        <template slot-scope="isPay">
                            <span v-if="isPay.row.isPay == 1">已支付</span>
                            <span v-else-if="isPay.row.isPay == 0">未支付</span>
                        </template>
                    </el-table-column>
                    <el-table-column label="操作" width="280">
                        <template slot-scope="scope">
                            <el-button size="mini" @click="download(scope.$index, scope.row)">下载</el-button>
                            <el-button size="mini" @click="upDate(scope.$index, scope.row)">编辑</el-button>
                            <el-button size="mini" type="danger" @click="del(scope.$index, scope.row)">删除</el-button>
                        </template>
                    </el-table-column>
                </el-table>
            </template>
            <div class="block">
                <el-pagination align='center' @size-change="handleSizeChange" @current-change="handleCurrentChange"
                    :current-page="currentPage" :page-sizes="[10, 12, 15, 20]" :page-size="pageSize"
                    layout="total, sizes, prev, pager, next" :total="tableDatas.length">
                </el-pagination>
            </div>
        </div>
    </div>
</template>
<script>
export default {
    data() {
        return {
            loading: false,
            tableDatas: [],
            tableData: [],
            currentPage: 1, // 当前页码
            pageSize: 12,// 每页的数据条数
            input: '',
            token: '',
            userId: 0,
            DiId: '',
            delegationInfoList: [],
            delegationInfo: {},
            fileList:[],
        }
    },
    methods: {
        //保留两位小数
        townum(val){
            return val.toFixed(2)
        },
        //每页条数改变时触发 选择一页显示多少行
        handleSizeChange(val) {
            this.currentPage = 1;
            this.pageSize = val;
        },
        //当前页改变时触发 跳转其他页
        handleCurrentChange(val) {
            this.currentPage = val;
        },
        //团组下拉框
        DecreasePaymentsSelect() {
            var url = "/api/Groups/DecreasePaymentsSelect"
            var that = this
            this.$axios({
                method: 'post',
                url: url,
                headers: {
                    Authorization: 'Bearer ' + this.token
                },
                data: {
                    UserId: that.userId,
                    CTId: 98
                }
            }).then(function (res) {
                if (res.data.code == 200) {
                    console.log(that.DiId)
                    that.delegationInfoList = res.data.data.groupName;
                    if(that.DiId!=that.DiId){
                        that.DiId = that.delegationInfoList[0].id;
                        that.delegationInfo = that.delegationInfoList[0];
                    }
                    that.DecreasePaymentsList();
                    that.DecreasePaymentsChange();
                }else{
                    console.log("400")
                }
            }).catch(function (error) {
                that.$message.error(error);
            });
        },
        DecreasePaymentsChange() {
            for (let index = 0; index < this.delegationInfoList.length; index++) {
                if (this.delegationInfoList[index].id == this.DiId) {
                    this.delegationInfo = this.delegationInfoList[index];
                    break;
                }
            }
            this.DecreasePaymentsList();
        },
        //团组信息绑定
        DecreasePaymentsList() {
            var url = "/api/Groups/DecreasePaymentsList"
            var that = this
            this.$axios({
                method: 'post',
                url: url,
                headers: {
                    Authorization: 'Bearer ' + this.token
                },
                data: {
                    userId:that.userId,
                    diId: that.DiId
                }
            }).then(function (res) {
                if (res.data.code == 200) {
                    that.tableDatas = res.data.data;
                    that.tableData = that.tableDatas
                    if (that.tableDatas.length != 0) {
                        if (that.tableDatas.slice((that.currentPage - 1) * that.pageSize, that.currentPage * that.pageSize).length == 0) {
                            if (that.currentPage > 1) {
                                that.currentPage = that.currentPage - 1;
                            }
                        }
                    }
                }
            }).catch(function (error) {
                //that.$message.error("网络错误，请稍后重试");
            });
        },
        upDate(index, row) {

            this.$router.push({
                path: "/home/OpDecreasePayments",
                query: {
                    DiId: this.DiId,
                    id: row.id
                }
            })

        },
        del(index, row) {
            this.$confirm('此操作将删除该数据, 是否继续?', '提示', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'warning'
            }).then(() => {
                var url = "/api/Groups/DelDecreasePayments"
                var that = this
                this.$axios({
                    method: 'post',
                    url: url,
                    headers: {
                        Authorization: 'Bearer ' + this.token
                    },
                    data: {
                        Id: row.id,
                        DeleteUserId: this.userId
                    }
                }).then(function (res) {
                    console.log(res)

                    if (res.data.code == 200) {

                        that.$message({
                            message: '删除成功',
                            type: 'success'
                        });
                        that.DecreasePaymentsSelect();
                    } else {
                        that.$message.error('删除失败！');
                    }
                    that.loading = false
                }).catch(function (error) {
                    that.loading = false
                    that.$message.error("网络错误，请稍后重试");
                });
            }).catch(() => {
                this.$message({
                    type: 'info',
                    message: '操作已取消！'
                });
            });
        },
        download(index, row) {
            if (row.filePath != "") {
                window.location.href = "http://132.232.92.186:24/Office/GrpFile/团组增减款项相关文件/" + row.filePath
            } else {
                this.$message.error("暂未上传附件");
            }

        },
        submitUpload() {
            this.$refs.upload.submit();
        },
        handleRemove(file, fileList) {
            console.log(file, fileList);
        },
        handlePreview(file) {
            console.log(file);
        },
        handleSuccess(response) {
            window.open(response.data.url)
            this.$message({
                message: response.msg,
                type: 'success'
            });
        },
        handleError(error) {
            this.$message.error(error.msg);
        },

    },
    filters:{
        filter_city(value){
            if(value){
                return value.replaceAll('|','、')
            }
        },
        filter_time(value){
            if(value){
                return value.split(" ")[0]
            }
        }
    },
    mounted() {
        this.DiId = Number(this.$route.query.DiId);
        this.token = JSON.parse(localStorage.getItem('userinif')).token;
        this.userId = JSON.parse(localStorage.getItem('userinif')).userInfo.userId
        this.DecreasePaymentsSelect();
        //this.AirTicketResList()
    }
}
</script>
<style>
.communal-list {
    background-color: #fff;
    padding: 10px;
    box-shadow: 0 0 5px #0005;
    border-radius: 10px;
    min-height: 830px;
}

.communal-title {
    display: flex;
    font-size: 17px;
    font-weight: 600;
    color: #555;
    margin-top: 8px;
    margin-bottom: 10px;
    justify-content: space-between;
    align-items: center;
}

.communal-box {
    display: flex;
}

.communal-box>button {
    margin-left: 10px;
    padding: 8px 20px;
}
.communal-box-title{
    font-size: 15px;
    margin: 10px 0;
}
.communal-box-title span{
    font-size: 16px;
    font-weight: 600;
    color: #555;
}
.dphade .el-upload-list__item{
    font-size: 12px;
}
</style>